import { defineComponent as V, mergeDefaults as w, ref as B, unref as t, openBlock as n, createElementBlock as m, Fragment as f, createTextVNode as E, toDisplayString as p, createElementVNode as q, normalizeClass as C, createCommentVNode as I } from "vue";
import { useFormWidget as M } from "./FormWidget.js";
import { useConfig as O } from "../config.js";
const W = ["required", "min", "max", "step", "inputmode", "value", "id"], _ = {
  key: 0,
  class: "cfb-mt-1 cfb-text-sm cfb-text-danger-600"
}, H = /* @__PURE__ */ V({
  __name: "NumberWidget",
  props: /* @__PURE__ */ w({
    path: {},
    targetPath: {},
    required: { type: Boolean },
    validate: { type: Boolean },
    hidden: { type: Boolean },
    default: {},
    empty: {},
    multipleOf: {},
    minimum: {},
    maximum: {},
    widgetId: {}
  }, O("NumberWidget", {
    empty: "N/A",
    multipleOf: 0.01
  })),
  setup(c) {
    const g = c, i = B(), {
      value: o,
      isRequired: v,
      setValue: u,
      register: b,
      validatedMeta: a,
      validator: y,
      validate: h,
      isValid: r,
      view: N
    } = M("NumberWidget", g);
    b({ validator: () => {
      var l;
      let e = i.value;
      return y(), e && (a.value.validity = e.checkValidity(), e.validationMessage && ((l = a.value).err ?? (l.err = [{ msg: e.validationMessage }]))), a.value;
    }, el: i });
    const k = (e) => {
      e.target instanceof HTMLInputElement && (e.target.value === "" ? u(void 0) : u(e.target.valueAsNumber), h());
    };
    return (e, l) => {
      var d, s;
      return t(N) ? (n(), m(f, { key: 0 }, [
        E(p(t(o) ?? e.empty), 1)
      ], 64)) : (n(), m(f, { key: 1 }, [
        q("input", {
          required: t(v)(),
          class: C([
            "cfb-rounded-lg cfb-p-1.5 cfb-min-w-0 cfb-w-full cfb-appearance-none",
            {
              "cfb-bg-valid-100 hover:cfb-bg-valid-200": t(r)() == !0,
              "cfb-bg-danger-100 hover:cfb-bg-danger-200": t(r)() == !1,
              "cfb-bg-gray-200 hover:cfb-bg-gray-300": t(r)() == null
            }
          ]),
          type: "number",
          min: e.minimum,
          max: e.maximum,
          step: e.multipleOf,
          inputmode: e.multipleOf == 1 ? "numeric" : "decimal",
          ref_key: "inputEl",
          ref: i,
          onInput: k,
          value: t(o),
          id: e.widgetId ?? e.path
        }, null, 42, W),
        (s = (d = t(a)) == null ? void 0 : d.err) != null && s[0].msg ? (n(), m("span", _, p(t(a).err[0].msg), 1)) : I("", !0)
      ], 64));
    };
  }
});
export {
  H as default
};
