import { defineComponent as M, mergeDefaults as C, ref as L, computed as h, unref as t, openBlock as i, createElementBlock as o, Fragment as s, createTextVNode as S, toDisplayString as u, normalizeClass as y, createElementVNode as x, renderList as I, createCommentVNode as N } from "vue";
import { useFormWidget as T } from "./FormWidget.js";
import { useConfig as W } from "../config.js";
import { useEnum as $ } from "../enum.js";
const D = ["id", "placeholder", "required", "value"], R = { value: "" }, j = ["value", "selected"], z = ["id", "required", "type", "minlength", "maxlength", "pattern", "value"], A = {
  key: 0,
  class: "cfb-mt-1 cfb-text-sm cfb-text-danger-600"
}, Q = /* @__PURE__ */ M({
  __name: "StringWidget",
  props: /* @__PURE__ */ C({
    path: {},
    targetPath: {},
    required: { type: Boolean },
    validate: { type: Boolean },
    hidden: { type: Boolean },
    widgetId: {},
    maxLength: {},
    minLength: {},
    pattern: {},
    empty: {},
    selectText: {},
    placeholder: {},
    type: {},
    prefix: {},
    suffix: {},
    formatFn: { type: Function },
    enum: {},
    enumMapperKey: {},
    disableEnumMapping: { type: Boolean },
    enumMapper: {}
  }, W("StringWidget", {
    selectText: "Select",
    empty: "N/A",
    prefix: "",
    suffix: ""
  })),
  setup(k) {
    const a = k, r = L(), { mappedEnum: f } = $(a), {
      value: n,
      isRequired: p,
      setValue: c,
      register: V,
      validatedMeta: d,
      validator: _,
      validate: w,
      isValid: l,
      view: q
    } = T("StringWidget", a);
    V({ validator: () => {
      var e;
      return _(), r.value && (d.value.validity = r.value.checkValidity(), r.value.validationMessage && ((e = d.value).err ?? (e.err = [{ msg: r.value.validationMessage }]))), d.value;
    }, el: r });
    const g = (e) => {
      e.target.value === "" ? c(void 0) : c(e.target.value), w();
    }, B = h(() => a.pattern instanceof RegExp ? a.pattern.source : a.pattern), E = h(() => a.formatFn ? a.formatFn(n.value) : a.prefix || a.suffix ? `${a.prefix}${n.value}${a.suffix}` : n.value);
    return (e, O) => {
      var m, v;
      return t(q) ? (i(), o(s, { key: 0 }, [
        S(u(E.value ?? e.empty), 1)
      ], 64)) : Object.keys(t(f)).length > 0 ? (i(), o("select", {
        key: 1,
        id: e.widgetId ?? e.path,
        class: y([
          "cfb-w-full cfb-rounded-lg cfb-p-1.5 cfb-appearance-none",
          {
            "cfb-bg-valid-100 hover:cfb-bg-valid-200": t(l)() == !0,
            "cfb-bg-danger-100 hover:cfb-bg-danger-200": t(l)() == !1,
            "cfb-bg-gray-200 hover:cfb-bg-gray-300": t(l)() == null
          }
        ]),
        placeholder: e.placeholder,
        required: t(p)(),
        value: t(n) ?? "",
        ref_key: "el",
        ref: r,
        onChange: g
      }, [
        x("option", R, u(e.selectText), 1),
        (i(!0), o(s, null, I(t(f), (F, b) => (i(), o("option", {
          value: b,
          selected: t(n) == b
        }, u(F), 9, j))), 256))
      ], 42, D)) : (i(), o(s, { key: 2 }, [
        x("input", {
          id: e.widgetId ?? e.path,
          required: t(p)(),
          class: y([
            "cfb-rounded-lg cfb-p-1.5 cfb-min-w-0 cfb-w-full cfb-appearance-none",
            {
              "cfb-bg-valid-100 hover:cfb-bg-valid-200": t(l)() == !0,
              "cfb-bg-danger-100 hover:cfb-bg-danger-200": t(l)() == !1,
              "cfb-bg-gray-200 hover:cfb-bg-gray-300": t(l)() == null
            }
          ]),
          type: e.type,
          minlength: e.minLength,
          maxlength: e.maxLength,
          pattern: B.value,
          ref_key: "el",
          ref: r,
          onInput: g,
          value: t(n)
        }, null, 42, z),
        (v = (m = t(d)) == null ? void 0 : m.err) != null && v[0].msg ? (i(), o("span", A, u(t(d).err[0].msg), 1)) : N("", !0)
      ], 64));
    };
  }
});
export {
  Q as default
};
