import { defineComponent as $, mergeDefaults as E, ref as b, watch as N, provide as F, openBlock as l, createElementBlock as r, normalizeClass as g, unref as o, createElementVNode as n, createCommentVNode as v, Fragment as z, renderList as O, withModifiers as R, createBlock as S, resolveDynamicComponent as G, mergeProps as J } from "vue";
import { set as K, deepClone as Q } from "@codeperate/utils";
import { columnClass as U } from "../utils/columns.utils.js";
import { useFormWidget as X } from "./FormWidget.js";
import { useConfig as Y } from "../config.js";
const Z = {
  key: 0,
  class: "cfb-flex cfb-justify-end cfb-gap-2"
}, ee = /* @__PURE__ */ n("i", { class: "fa-solid fa-minus" }, null, -1), te = [
  ee
], oe = /* @__PURE__ */ n("i", { class: "fa-solid fa-plus" }, null, -1), ae = [
  oe
], le = {
  class: /* @__PURE__ */ g(["cfb-grid des:cfb-grid-cols-12 mob:cfb-grid-cols-6 cfb-gap-4"])
}, re = ["innerHTML"], ne = ["innerHTML"], se = ["draggable", "onDragstart", "onDragover"], ie = ["onClick"], ce = /* @__PURE__ */ n("i", { class: "fa-solid fa-xmark cfb-text-[10px]" }, null, -1), fe = [
  ce
], ge = /* @__PURE__ */ $({
  __name: "ArrayWidget",
  props: /* @__PURE__ */ E({
    path: {},
    targetPath: {},
    required: { type: Boolean },
    validate: { type: Boolean },
    hidden: { type: Boolean },
    joinValues: { type: Boolean },
    addable: { type: Boolean },
    deletable: { type: Boolean },
    movable: { type: Boolean },
    minItems: {},
    maxItems: {},
    columns: {},
    emptyText: {},
    pagination: { type: [Boolean, Object] },
    defaultItem: { type: Boolean },
    sortable: { type: Boolean },
    background: { type: Boolean }
  }, Y("ArrayWidget", {
    addable: !0,
    deletable: !0,
    emptyText: "No items",
    movable: !0,
    joinValues: !1,
    pagination: () => ({
      limit: 10
    }),
    columns: 6,
    defaultItem: !0,
    sortable: !0
  })),
  setup(A) {
    const y = A, f = X("ArrayWidget", y), { register: I, setValue: d, getPathArr: M, isValid: h, isRequired: T, value: t, schema: _, view: s, validator: H, form: W } = f, x = b();
    I({
      el: x,
      validator: () => (H(), T() && (t.value == null || t.value.length == 0) && (f.validatedMeta.value.validity = !1), f.validatedMeta.value),
      onExportValue: async (e) => {
        K(
          e,
          ["value", ...f.getPathArr()],
          t.value.filter((a) => a)
        );
      }
    });
    const k = (e) => {
      var a;
      t.value && (e != null ? d(t.value.filter((m, u) => u != e)) : d((a = t.value) == null ? void 0 : a.slice(e, -1)));
    }, B = () => {
      d([...t.value ?? [], void 0]);
    };
    y.defaultItem && t.value == null && B();
    const w = b(1), C = b(), p = b(), q = (e) => {
      p.value = e;
    }, L = (e) => {
      w.value = e, C.value = Q(t.value[e]), p.value = void 0;
    };
    N(p, (e, a) => {
      e != null && (t.value.splice(a ?? w.value, 1), t.value.splice(e, 0, C.value), d([...t.value]));
    }), F("ArrayWidget", { inArrayWidget: !0 });
    const P = () => {
      var a;
      let e = ((a = _.items) == null ? void 0 : a.props) ?? {};
      return typeof e == "function" ? e({ form: W }) : e;
    };
    return (e, a) => {
      var m, u, j;
      return l(), r("div", {
        class: g([
          "cfb-p-2 cfb-rounded-lg cfb-grid cfb-gap-2",
          {
            "cfb-bg-danger-200": o(h)() == !1,
            "cfb-bg-gray-50": o(h)() !== !1
          }
        ]),
        ref_key: "el",
        ref: x
      }, [
        o(s) ? v("", !0) : (l(), r("div", Z, [
          n("button", {
            onClick: a[0] || (a[0] = (i) => k()),
            class: "cfb-bg-main-700 hover:cfb-bg-main-800 cfb-text-white cfb-w-8 cfb-flex cfb-justify-center cfb-items-center cfb-aspect-square cfb-px-4 cfb-py-1 cfb-rounded"
          }, te),
          n("button", {
            onClick: B,
            class: "cfb-bg-main-700 hover:cfb-bg-main-800 cfb-text-white cfb-w-8 cfb-flex cfb-justify-center cfb-items-center cfb-aspect-square cfb-px-4 cfb-py-1 cfb-rounded"
          }, ae)
        ])),
        n("div", le, [
          o(s) && (!o(t) || ((m = o(t)) == null ? void 0 : m.filter((i) => i).length) == 0) ? (l(), r("div", {
            key: 0,
            class: "cfb-col-span-full",
            innerHTML: e.emptyText
          }, null, 8, re)) : v("", !0),
          o(s) && e.joinValues ? (l(), r("div", {
            key: 1,
            innerHTML: (u = o(t)) == null ? void 0 : u.join(",")
          }, null, 8, ne)) : (l(!0), r(z, { key: 2 }, O(o(s) ? (j = o(t)) == null ? void 0 : j.filter((i) => i) : o(t), (i, c) => {
            var D;
            return l(), r("div", {
              key: c,
              class: g([o(U)(e.columns), "cfb-relative cfb-group cfb-p-2 hover:cfb-ring-2 hover:cfb-ring-main-700 cfb-rounded-lg"]),
              draggable: e.sortable,
              onDragstart: (V) => L(c),
              onDragover: R((V) => q(c), ["prevent", "stop"])
            }, [
              o(s) ? v("", !0) : (l(), r("button", {
                key: 0,
                onClick: (V) => k(c),
                class: "cfb-hidden group-hover:cfb-flex cfb-absolute -cfb-right-2 -cfb-top-2 cfb-bg-main-700 cfb-aspect-square cfb-items-center cfb-w-4 cfb-justify-center cfb-rounded-full cfb-text-white"
              }, fe, 8, ie)),
              (l(), S(G((D = o(_).items) == null ? void 0 : D.widget.component), J({
                path: [...o(M)(), c].join("."),
                ref_for: !0
              }, P()), null, 16, ["path"]))
            ], 42, se);
          }), 128))
        ])
      ], 2);
    };
  }
});
export {
  ge as default
};
