import { defineComponent as k, mergeDefaults as x, ref as W, openBlock as i, createElementBlock as a, Fragment as v, renderList as A, unref as l, normalizeClass as E, createElementVNode as H, createCommentVNode as u, createBlock as I, resolveDynamicComponent as K, mergeProps as L } from "vue";
import { get as V } from "@codeperate/utils";
import { columnClass as $ } from "../utils/columns.utils.js";
import { useFormWidget as w } from "./FormWidget.js";
import { useConfig as D } from "../config.js";
const F = ["data-testid"], M = {
  key: 0,
  class: "cfb-font-bold"
}, N = ["innerHTML"], T = {
  key: 0,
  class: "cfb-text-danger-600"
}, R = /* @__PURE__ */ k({
  __name: "ObjectWidget",
  props: /* @__PURE__ */ x({
    path: {},
    targetPath: {},
    required: { type: Boolean },
    validate: { type: Boolean },
    hidden: { type: Boolean },
    removeAdditionalProperties: { type: Boolean },
    reserveKey: {},
    testIdPrefix: {}
  }, D("ObjectWidget", {
    removeAdditionalProperties: !0,
    reserveKey: () => [],
    testIdPrefix: "form"
  })),
  setup(y) {
    const d = y, { register: _, getPath: P, getSchema: h, form: j } = w("ObjectWidget", d), B = async (e, t) => {
      var p;
      const o = d.reserveKey;
      if (t.removeAdditional && d.removeAdditionalProperties) {
        const n = V(e, `value.${P()}`);
        if (n && n instanceof Object) {
          for (let s in h().properties) {
            const r = (p = h().properties) == null ? void 0 : p[s];
            r != null && r.hidden && (typeof r.hidden == "function" ? r.hidden(f) : r.hidden) || o.push(s.split(".")[0]);
          }
          for (let s in n)
            o.includes(s) || delete n[s];
        }
      }
    }, g = W(), f = _({ el: g, onExportValue: B }), { schema: m } = f;
    if (!m.value.properties) throw new Error("ObjectWidget must have properties");
    const C = (e) => {
      var o;
      let t = ((o = m.value.properties) == null ? void 0 : o[e].props) ?? {};
      return typeof t == "function" ? t({ form: j }) : t;
    }, b = (e, t) => [...e.split(".").filter((o) => o), t].join("."), O = (e, t) => `${d.testIdPrefix}:${b(e, t)}`;
    return (e, t) => (i(), a("div", {
      class: "cfb-grid des:cfb-grid-cols-12 mob:cfb-grid-cols-6 cfb-gap-4",
      ref_key: "el",
      ref: g
    }, [
      (i(!0), a(v, null, A(l(m).properties, ({ widget: o, label: p, hidden: n, columns: s, required: r }, c) => (i(), a(v, { key: c }, [
        (typeof n == "function" ? n(l(f)) : n) ? u("", !0) : (i(), a("div", {
          key: 0,
          class: E(["cfb-grid cfb-content-start", l($)(s ?? o.columns ?? 6)]),
          "data-testid": O(e.path, c)
        }, [
          p != !1 ? (i(), a("label", M, [
            H("span", {
              innerHTML: p ?? c
            }, null, 8, N),
            (typeof r == "function" ? r(l(f)) : r) ? (i(), a("span", T, "*")) : u("", !0)
          ])) : u("", !0),
          (i(), I(K(o.component), L({
            path: b(e.path, c),
            ref_for: !0
          }, C(c)), null, 16, ["path"]))
        ], 10, F))
      ], 64))), 128))
    ], 512));
  }
});
export {
  R as default
};
